Subject: Re: [Netmod-ver-dt] Today's meeting minutes

From: "Reshad Rahman (rrahman)" <[email-masked]>
Date: Thu, 27 Feb 2020 03:01:05 +0000

Hi Rob, all,

See below, TBH I’m not sure I’ve captured everything you had mind.

Also heads-up that I’m on PTO (no connectivity) the week before IETF…

Regards,
Reshad.

OLD
5.4.2.  RESTCONF

   For RESTCONF, schema-sets are chosen via use of their name in the
   request path.

   Clients select the desired schema-set by choosing the corresponding
   RESTCONF root resource

   This updates Section 3.1 of [RFC8040].  For example, consider a
   device which has been configured with root-path "/restconf/example-
   ietf-routing-1.3.1" for secondary schema-set "example-ietf-routing-
   1.3.1".  Any operations by the client on schema-set "example-ietf-
   routing-1.3.1" would use "/restconf/example-ietf-routing-1.3.1" as
   the RESTCONF root resource.

NEW
5.4.2.  RESTCONF

   For RESTCONF, schema-sets are chosen via use of their name in the
   request URI.

   Clients select the desired schema-set by choosing the corresponding
   RESTCONF root resource. This is done by appending the schema-set name to
   the RESTCONF API root [RFC8040]. This updates Section 3.1 of [RFC8040].

   Consider a device which supports schema-sets [email-masked]<mailto:[email-masked]>,
   [email-masked]<mailto:[email-masked]> and [email-masked]<mailto:[email-masked]>. Assuming the RESTCONF API
   root returned by the device is ”/restconf”, the client will use RESTCONF
  root resource /restconf/[email-masked]<mailto:/restconf/[email-masked]> for all requests pertaining to
  resources defined in schema-set [email-masked]<mailto:[email-masked]>. This applies to all
   RESTCONF resources defined in [email-masked]<mailto:[email-masked]>, for example:

1)  /restconf/[email-masked]/data<mailto:/restconf/[email-masked]/data> for datastore resource.

2)  /restconf/[email-masked]/data/module-A:data-X<mailto:/restconf/[email-masked]/data/module-A:data-X> for data resource
”data-X” defined in module ”module-A”.

3)  /restconf/[email-masked]/operations/module-B:op-Y<mailto:/restconf/[email-masked]/operations/module-B:op-Y> for RPC

”op-Y” defined in module ”module-B”

4)  /restconf/[email-masked]/data/module-C:containerZ/myaction<mailto:/restconf/[email-masked]/data/module-C:containerZ/myaction> for

action “myaction” defined  in top-container “containerZ” of module

”module-C”

From: Netmod-ver-dt <[email-masked]> on behalf of "Rob Wilton (rwilton)" <rwilton=[email-masked]>
Date: Tuesday, February 25, 2020 at 10:10 AM
To: "[email-masked]" <[email-masked]>
Subject: [Netmod-ver-dt] Today's meeting minutes

I think that this is the conclusion from today’s meeting, please send anything that I’ve missed.

Aim to get updated text by Wed’s evening, Rob will merge on Thurs, hopefully review and post on Friday.

Bo:

  *   Clarify or give a better explanation of schema-set earlier in the document.
  *   Clean up example 1 in appendix.

Jason:

  *   Provide text about what sessions, i.e. cannot change schema in a session, kicking clients off if the session is changed, and what we are discussing in the first half of today’s meeting.

Reshad:

  *   Improve/expand RESTCONF text, e.g. define what the path is used to access the RESTCONF resources, highlight that this applies to all NETCONF resources, RPCs, datastores, etc.

Rob:

  *   Delete RPC from model, section 6, and check other text
  *   Fix up intro text in section 10.
  *   Process nits/other comments raised by Reshad/Jason
  *   Improve the second appendix example, perhaps remove custom schema from the example.

Thanks,
Rob

---

From: "Rob Wilton (rwilton)" <[email-masked]>
Date: Thu, 27 Feb 2020 13:39:14 +0000

Hi Reshad,

Yes, this is along the lines that I was thinking of, but perhaps want to include a prefix for schema selection, and perhaps should align to the datastore paths in rfc8527.

I.e. perhaps
 {+restconf}/schema/<schema-name>/ds/<dsname>

E.g. “/restconf/schema/[email-masked]/ds/ietf-datastores:running/”, etc.

Thanks,
Rob

From: Reshad Rahman (rrahman) <rrahman=[email-masked]>
Sent: 27 February 2020 03:01
To: Rob Wilton (rwilton) <[email-masked]>
Cc: [email-masked]
Subject: Re: [Netmod-ver-dt] Today's meeting minutes

Hi Rob, all,

Regards,
Reshad.

OLD
5.4.2.  RESTCONF

NEW
5.4.2.  RESTCONF

  1.  /restconf/[email-masked]/data<mailto:/restconf/[email-masked]/data> for datastore resource.
  2.  /restconf/[email-masked]/data/module-A:data-X<mailto:/restconf/[email-masked]/data/module-A:data-X> for data resource
”data-X” defined in module ”module-A”.

  1.  /restconf/[email-masked]/operations/module-B:op-Y<mailto:/restconf/[email-masked]/operations/module-B:op-Y> for RPC

  1.  /restconf/[email-masked]/data/module-C:containerZ/myaction<mailto:/restconf/[email-masked]/data/module-C:containerZ/myaction> for

”module-C”

From: Netmod-ver-dt <[email-masked]<mailto:[email-masked]>> on behalf of "Rob Wilton (rwilton)" <rwilton=[email-masked]<mailto:rwilton=[email-masked]>>
Date: Tuesday, February 25, 2020 at 10:10 AM
To: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Subject: [Netmod-ver-dt] Today's meeting minutes

Bo:

Jason:

Reshad:

Rob:

Thanks,
Rob

---

From: "Reshad Rahman (rrahman)" <[email-masked]>
Date: Thu, 27 Feb 2020 16:14:14 +0000

Hi Rob,

Indeed NMDA should be in there. What about supporting both NMDA(rfc8527) and non-NMDA(rfc8040)? Here is take 2.

5.4.2.  RESTCONF

   Clients select the desired schema-set by choosing the corresponding
   RESTCONF root resource. This is done by appending the schema-set name to
   the RESTCONF API root [RFC8040]. This updates Section 3.1 of [RFC8040] and
   section 3 of [RFC8527].

   Clients will use RESTCONF root resource {+restconf}/schema/<schema-name>
   for all requests pertaining to resources specific to a schema-set.
   Consider a device which supports schema-sets [email-masked]<mailto:[email-masked]>,
   [email-masked]<mailto:[email-masked]> and [email-masked]<mailto:[email-masked]>: clients will use RESTCONF
   root resource {+restconf}/schema/[email-masked]<mailto:%7b+restconf%7d/schema/[email-masked]> for all requests
   pertaining to resources defined in schema-set [email-masked]<mailto:[email-masked]>. This
   applies to all RESTCONF resources defined in [email-masked]<mailto:[email-masked]>.

   Here are some examples where {+restconf} is /restconf/.

   Examples for servers which are NOT NMDA-compliant as per [RFC8527]:

  1.  /restconf/schema/[email-masked]/data<mailto:/restconf/schema/[email-masked]/data> for datastore resources.
  2.  /restconf/schema/[email-masked]/data/module-A:data-X<mailto:/restconf/schema/[email-masked]/data/module-A:data-X> for data resource
”data-X” defined in module ”module-A”.

  1.  /restconf/schema/[email-masked]/operations/module-B:op-Y<mailto:/restconf/schema/[email-masked]/operations/module-B:op-Y> for RPC

  1.  /restconf/schema/[email-masked]/data/module-C:containerZ/myaction<mailto:/restconf/schema/[email-masked]/data/module-C:containerZ/myaction> for

”module-C”

   Examples for servers which are NMDA-compliant as per [RFC8527]:

  1.   /restconf/schema/[email-masked]/ds/<datastore>/<mailto:/restconf/schema/[email-masked]/ds/%3cdatastore%3e/> for datastore resources, e.g.

/restconf/schema/[email-masked]/ds/ietf-datastores:running<mailto:/restconf/schema/[email-masked]/ds/ietf-datastores:running> refers to the

Running configuration datastore.

  1.  /restconf/schema/[email-masked]/ds/ietf-datastores:operational for YANG actions.

Regards,
Reshad.

From: "Rob Wilton (rwilton)" <rwilton=[email-masked]>
Date: Thursday, February 27, 2020 at 8:39 AM
To: "Reshad Rahman (rrahman)" <[email-masked]>
Cc: "[email-masked]" <[email-masked]>
Subject: RE: [Netmod-ver-dt] Today's meeting minutes

Hi Reshad,

I.e. perhaps

Thanks,
Rob

Hi Rob, all,

Regards,
Reshad.

OLD
5.4.2.  RESTCONF

NEW
5.4.2.  RESTCONF

”module-C”

Bo:

Jason:

Reshad:

Rob:

Thanks,
Rob

---

From: "Rob Wilton (rwilton)" <[email-masked]>
Date: Thu, 27 Feb 2020 17:46:23 +0000

Hi Reshad,

Yes, I think that is good.  I was going to suggest giving examples of accessing nodes with a datastore, but perhaps better to leave that to rfc8527?

Anyway, are you okay to commit/merge this?

Thanks,
Rob

Sent: 27 February 2020 16:14

Hi Rob,

5.4.2.  RESTCONF

”module-C”

  1.  /restconf/schema/[email-masked]/ds/ietf-datastores:operational<mailto:/restconf/schema/[email-masked]/ds/ietf-datastores:operational> for YANG actions.

Regards,
Reshad.

From: "Rob Wilton (rwilton)" <rwilton=[email-masked]<mailto:rwilton=[email-masked]>>
Date: Thursday, February 27, 2020 at 8:39 AM
To: "Reshad Rahman (rrahman)" <[email-masked]<mailto:[email-masked]>>
Cc: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Subject: RE: [Netmod-ver-dt] Today's meeting minutes

Hi Reshad,

I.e. perhaps

E.g. “/restconf/schema/[email-masked]/ds/ietf-datastores:running/<mailto:/restconf/schema/[email-masked]/ds/ietf-datastores:running/>”, etc.

Thanks,
Rob

From: Reshad Rahman (rrahman) <rrahman=[email-masked]<mailto:rrahman=[email-masked]>>
Sent: 27 February 2020 03:01
To: Rob Wilton (rwilton) <[email-masked]<mailto:[email-masked]>>
Cc: [email-masked]<mailto:[email-masked]>
Subject: Re: [Netmod-ver-dt] Today's meeting minutes

Hi Rob, all,

Regards,
Reshad.

OLD
5.4.2.  RESTCONF

NEW
5.4.2.  RESTCONF

”module-C”

Bo:

Jason:

Reshad:

Rob:

Thanks,
Rob

---

From: "Reshad Rahman (rrahman)" <[email-masked]>
Date: Thu, 27 Feb 2020 20:30:11 +0000

Rob, I just pushed the changes to develop branch (latest rev attached). I didn’t add examples of accessing nodes with a datastore.

Regards,
Reshad.

Date: Thursday, February 27, 2020 at 12:46 PM

Hi Reshad,

Thanks,
Rob

Hi Rob,

5.4.2.  RESTCONF

”module-C”

Regards,
Reshad.

Hi Reshad,

I.e. perhaps

Thanks,
Rob

Hi Rob, all,

Regards,
Reshad.

OLD
5.4.2.  RESTCONF

NEW
5.4.2.  RESTCONF

”module-C”

Bo:

Jason:

Reshad:

Rob:

Thanks,
Rob